'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Connector = undefined;

var _utils = require('./utils');

var _utils2 = _interopRequireDefault(_utils);

var _socket = require('socket.io');

var _socket2 = _interopRequireDefault(_socket);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 *  Handle methods for creating APIs
 */
class Connector {
  constructor(mighty) {
    this.config = mighty.config;
    this.app = mighty;
    this.connector = null;
    this.connections = {};
  }

  authorizeConnection(data) {}

  addConnection(c) {
    this.connections[c.id] = c;
    return this;
  }

  removeConnection(c) {
    delete this.connections[c.id];
    return this;
  }

  handleConnect(socket) {
    socket.on('*', this.handleRequest);
  }

  handleRequest(packet) {}

  handleResponse() {}

  start(port) {
    var _this = this;
    port = port ? port : _this.config.connect_port || 3459;
    _this.connector = _socket2.default.listen(port);
    _this.connector.use(require('socketio-wildcard')());
    _this.connector.on('connection', this.handleConnect);
    console.log(_this.config.application_name + ' Connector listening on :::' + port);
    return _this.connector;
  }
}
exports.Connector = Connector;