'use strict';

var _config = require('./config.js');

var _config2 = _interopRequireDefault(_config);

var _login = require('./login.js');

var _login2 = _interopRequireDefault(_login);

var _register = require('./register.js');

var _register2 = _interopRequireDefault(_register);

var _user = require('./user.js');

var _user2 = _interopRequireDefault(_user);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
  * Users are the basis for authentication and are made up of an email address and password used to authenticate and generate and authentication_key
  *
  * @class UserModule
  *
  */
class UsersModule {
  constructor(app) {
    this.config = _config2.default;

    // add other stuff to the module here.

    this.login = new _login2.default(app);
    this.register = new _register2.default(app);
    this.user = new _user2.default(app);

    this.config.routes = {
      '/auth/login': {
        method: 'post',
        controller: this.login.handleLogin
      },
      '/auth/current': {
        method: 'get',
        authentication: true,
        controller: this.user.handleGetUser
      },
      '/auth/register': {
        method: 'post',
        controller: this.register.handleRegister
      },
      '/auth/forgot-password': {
        method: 'post',
        controller: this.login.handleForgotPassword
      },
      '/auth/reset-password/:reset_code': {
        method: 'post',
        controller: this.login.handleResetPassword
      }
    };
  }

  static get config() {
    return _config2.default;
  }
}

module.exports = UsersModule;